Ubuntu sunucumu yeniden başlattığımda sfenksin yeniden başlatılmasını nasıl sağlayabilirim?


12

Ubuntu 9.04 sunucuma sfenks araması yaptım ve yükledim.

Yeniden başlattığımda sfenks arka plan programının otomatik olarak başlamasını nasıl sağlayabilirim?

Yanıtlar:


13

Sfenks'i bilmiyorum, ama temel yaklaşım burada. Aşağıdaki içeriklere sahip bir /etc/init.d/searchd dosyası oluşturun ( bu komut dosyası da vardır , ancak muhtemelen biraz ayarlamanız gerekir):

#!/bin/bash

case "${1:-''}" in
  'start')
        # put the command to start sphinx
        # i.e., /usr/bin/searchd start or /usr/bin/searchd --daemon or whatever the command is
        ;;
  'stop')
        # stop command here
        ;;
  'restart')
        # restart command here
        ;;
  *)
        echo "Usage: $SELF start|stop|restart"
        exit 1
        ;;
esac

Ardından aşağıdakileri yürütün:

$ sudo update-rc.d searchd defaults

Hizmeti manuel olarak kontrol etmek için:

$ sudo /etc/init.d/searchd <start|stop|restart>

Bu senaryo mükemmel çalıştı. Kayıt için, kullandığım start / stop / restart komutları. Bu bir Ubuntu Hardy sunucusunda ve sfenks 0.9.8.1 sürümünü yayından yükledim. start / usr / local / bin / searchd stop / usr / local / bin / searchd - stop restart / usr / local / bin / searchd --stop && / usr / local / bin / searchd
Apreche

Bir cazibe gibi çalıştı. Dikkat edilecek tek bir kelime: searchd dosyasının uygun izinlere sahip olduğundan emin olun.
David

1

Debian sistemlerinde bir müşteri için Sphinx'i kullandık ve süreçleri yönetmek için Runit'i kullandık . Özel bir init betiği yazmak zorunda değildik ve Runit'i diğer platformlarda (ağırlıklı olarak CentOS / RHEL) kullandığımızdan beri mükemmel taşınabilirdi.


1

Yazma sırasında ubuntu için paketlenen sfenks sürümü (0.99) aşağıdaki başlangıç ​​komut dosyasına sahiptir.

Kaynaktan derlediğim 2.0.1 beta için tekrar kullandım, sadece satırı değiştirdim DAEMON=/usr/local/..ve benim için çalışıyor.

#! /bin/sh
#
#       Written by Miquel van Smoorenburg <miquels@cistron.nl>.
#       Modified for Debian
#       by Ian Murdock <imurdock@gnu.ai.mit.edu>.
#               Further changes by Javier Fernandez-Sanguino <jfs@debian.org>
#               Modified for sphinx by Radu Spineanu <radu@debian.org>
#
#

### BEGIN INIT INFO
# Provides:          sphinxsearch
# Required-Start:    $local_fs $remote_fs $syslog $network $time
# Required-Stop:     $local_fs $remote_fs $syslog $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Fast standalone full-text SQL search engine
### END INIT INFO


PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/sphinx/bin/searchd
NAME=sphinxsearch
DESC=sphinxsearch

test -x $DAEMON || exit 0

LOGDIR=/var/log/sphinxsearch
PIDFILE=/var/run/searchd.pid
DODTIME=1                   # Time to wait for the server to die, in seconds
                            # If this value is set too low you might not
                            # let some servers to die gracefully and
                            # 'restart' will not work

# Include sphinxsearch defaults if available
if [ -f /etc/default/sphinxsearch ] ; then
    . /etc/default/sphinxsearch
fi

if [ "$START" != "yes" ]; then
  echo "To enable $NAME, edit /etc/default/sphinxsearch and set START=yes"
  exit 0
fi


set -e

running_pid()
{
    # Check if a given process pid's cmdline matches a given name
    pid=$1
    name=$2
    [ -z "$pid" ] && return 1
    [ ! -d /proc/$pid ] &&  return 1
    cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
    # Is this the expected child?
    [ "$cmd" != "$name" ] &&  return 1
    return 0
}

running()
{
# Check if the process is running looking at /proc
# (works for all users)

    # No pidfile, probably no daemon present
    [ ! -f "$PIDFILE" ] && return 1
    # Obtain the pid and check it against the binary name
    pid=`cat $PIDFILE`
    running_pid $pid $DAEMON || return 1
    return 0
}

force_stop() {
# Forcefully kill the process
    [ ! -f "$PIDFILE" ] && return
    if running ; then
        kill -15 $pid
        # Is it really dead?
        [ -n "$DODTIME" ] && sleep "$DODTIME"s
        if running ; then
            kill -9 $pid
            [ -n "$DODTIME" ] && sleep "$DODTIME"s
            if running ; then
                echo "Cannot kill $LABEL (pid=$pid)!"
                exit 1
            fi
        fi
    fi
    rm -f $PIDFILE
    return 0
}

case "$1" in
  start)
        echo -n "Starting $DESC: "

        # Check if we have the configuration file
        if [ ! -f /etc/sphinxsearch/sphinx.conf ]; then
            echo "Please create an /etc/sphinxsearch/sphinx.conf configuration file."
            echo "Templates are in the /etc/sphinxsearch/ directory."
            exit 0
        fi

        start-stop-daemon --start --exec ${DAEMON}
        if running ; then
            echo "$NAME."
        else
            echo " ERROR."
        fi
        ;;
  stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \
            --exec $DAEMON
        echo "$NAME."
        ;;
  force-stop)
        echo -n "Forcefully stopping $DESC: "
        force_stop
        if ! running ; then
            echo "$NAME."
        else
            echo " ERROR."
        fi
        ;;
  restart)
    echo -n "Restarting $DESC: "
        start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE \
            --exec $DAEMON
        [ -n "$DODTIME" ] && sleep $DODTIME
        start-stop-daemon --start --exec ${DAEMON}
        echo "$NAME."
        ;;

  status)
    echo -n "$LABEL is "
    if running ;  then
        echo "running"
    else
        echo " not running."
        exit 1
    fi
    ;;
  *)
    N=/etc/init.d/$NAME
    # echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
    echo "Usage: $N {start|stop|restart|force-reload|status|force-stop}" >&2
    exit 1
    ;;
esac

exit 0

Bu da benim için çalıştı!
ChrisInCambo

0

Sfenks'i gerçekten bilmiyorum, ancak çevrimiçi el kitabına bakarak, arka plan programını çalıştırmak için bir başlangıç ​​komut dosyasına ihtiyacınız var. Bu genellikle /etc/init.d dizininde bir girdi oluşturup uygun /etc/rcX.d dizinine bağlayarak yapılır. Ayrıntılar için /etc/init.d dosyasındaki README dosyasına bakın.

Başka bir şey yoksa, böyle bir şey hızlı ve kirli cevaptır:

$ cat > /etc/init.d/sphinx
cd /usr/local/sphinx/etc
/usr/local/sphinx/bin/searchd
^D
$ ln -s /etc/init.d/sphinx /etc/init.d/rc3.d/S99sphinx

0

İçinde aşağıdaki satırın eşdeğeri olan bir kısa komut dosyası (belki bash) oluşturun:

/ path / to / sphinx / installation / searchd --config /path/to/sphinx/config/sphinx.conf &

Sonra komut dosyasını /etc/init.d dosyasına kök olarak taşıyın ve komut dosyasını chmodlayın ("chmod + x myscript.sh")


0

/Etc/init.d dizinine yeniden başlatma komut dosyası ekleyin.


0

Daha da basit bir çözüm öneririm:

Sadece eklemek / usr / bin / searchd için /etc/rc.local diyor satırdan önce çıkış 0


0

Eğer raylar uygulamada sfenks kullanmak olur ne zaman gem ile bunu yönetmek için ölü kolay bir yoludur .

Ryan Bates bu konuda çok iyi bir screencast yaptı. Bu site buraya birden fazla bağlantı eklememe izin vermiyor, ancak öneriyorum.


Sitemizi kullandığınızda şunları okuyup anladığınızı kabul etmiş olursunuz: Çerez Politikası ve Gizlilik Politikası.
Licensed under cc by-sa 3.0 with attribution required.